/**
 * @author bcoxie
 */

function Bat()
{
	this.width = 100;
	this.height = 100;
	this.x = Math.random() * mWidth;// + mWidth;
	this.y = Math.random() * (mGroundHeight - this.height);
	this.scrollSpeed = -200;
	this.maxHp = 1;
	this.hp = 1;
	this.alive = true;
	this.killPoints = 25;
	this.scoreSpeedThresh = 50;
	this.currSprite = 1;
	this.slowTime = 2;
	this.maxScrollSpeed = -1000;
	
	var img = new Image();
	img.src = "images/bat1.png";
	this.sprite1 = new Sprite(img, 0, 0, 100, 100);
	
	img = new Image();
	img.src = "images/bat2.png";
	this.sprite2 = new Sprite(img, 0, 0, 100, 100);
	
	img = new Image();
	img.src = "images/pointstwentyfive.png";
	this.destroyedSprite= new Sprite(img, 0, 0, 128, 128);
}

Bat.prototype.draw = function(context)
{
	if (this.hp > 0)
	{
		if (this.currSprite < 2)
		{
			this.sprite1.draw(context, this.x, this.y, this.width, this.height);
			this.currSprite += 0.2;
		}
		else
		{
			this.sprite2.draw(context, this.x, this.y, this.width, this.height);
			this.currSprite += 0.2;
		}
		
		if (this.currSprite >= 3)
		{
			this.currSprite = 1;
		}
	}
	else
	{
		this.destroyedSprite.draw(context, this.x, this.y, this.width, this.height);
	}
};

Bat.prototype.update = function(deltaTime)
{
	if (mScore > this.scoreSpeedThresh)
	{
		//mTD = this.scrollSpeed * (mScore / this.scoreSpeedThresh);
		if (Math.abs(this.scrollSpeed * (mScore / this.scoreSpeedThresh)) > Math.abs(this.maxScrollSpeed))
		{
			this.x += this.maxScrollSpeed * deltaTime;
		}
		else
		{
			this.x += this.scrollSpeed * deltaTime * (mScore / this.scoreSpeedThresh);
		}
	}
	else
	{
		this.x += this.scrollSpeed * deltaTime;
	}
	
	if (this.alive && this.hp <= 0)
	{
		this.alive = false;
		mScore += this.killPoints;
		mBatSlowDown = this.slowTime;
	}
	
	if (this.x < 0 - this.width)
	{
		this.x = mWidth;
		this.y = Math.random() * (mGroundHeight - this.height);
		this.hp = this.maxHp;
		this.alive = true;
	}
};
