/**
 * @author bcoxie
 */

function Block()
{
	this.width = 100;
	this.height = 100;
	this.x = Math.random() * mWidth;// + mWidth;
	this.y = Math.random() * (mGroundHeight - this.height);
	this.scrollSpeed = -80;
	this.maxHp = 4;
	this.hp = 4;
	this.alive = true;
	this.killPoints = 10;
	this.scoreSpeedThresh = 50;
	
	var img = new Image();
	img.src = "images/block.png";
	this.sprite= new Sprite(img, 0, 0, 128, 128);
	
	img = new Image();
	img.src = "images/blockcracked.png";
	this.crackedSprite= new Sprite(img, 0, 0, 128, 128);
	
	img = new Image();
	img.src = "images/pointsten.png";
	this.destroyedSprite= new Sprite(img, 0, 0, 128, 128);
}

Block.prototype.draw = function(context)
{
	if (this.hp > this.maxHp / 2)
	{
		this.sprite.draw(context, this.x, this.y, this.width, this.height);
	}
	else if (this.hp > 0)
	{
		this.crackedSprite.draw(context, this.x, this.y, this.width, this.height);
	}
	else
	{
		this.destroyedSprite.draw(context, this.x, this.y, this.width, this.height);
	}
};

Block.prototype.update = function(deltaTime)
{
	if (mScore > this.scoreSpeedThresh)
	{
		if (mBatSlowDown > 0)
		{
			this.x += this.scrollSpeed * deltaTime * (mScore / this.scoreSpeedThresh) * mBatSlowEffect;
		}
		else
		{
			this.x += this.scrollSpeed * deltaTime * (mScore / this.scoreSpeedThresh);
		}
	}
	else
	{
		this.x += this.scrollSpeed * deltaTime;
	}
	
	if (this.alive && this.hp <= 0)
	{
		this.alive = false;
		mScore += this.killPoints;
	}
	
	if (this.x < 0 - this.width)
	{
		this.x = mWidth;
		this.y = Math.random() * (mGroundHeight - this.height);
		this.hp = this.maxHp;
		this.alive = true;
	}
};
