/**
 * @author bcoxie
 */

function DashParticle()
{
	this.x = 0;
	this.y = 0;
	this.width = 50;
	this.height = 50;
	this.lifeTime = 0.5;
	this.currLife = 0;
	this.velocityX = 0;
	this.velocityY = 0;
	this.velocityFactor = 100;
	
	var img = new Image();
	img.src = "images/dashparticle.png";
	this.sprite= new Sprite(img, 0, 0, 32, 32);
}

DashParticle.prototype.draw = function(context)
{
	if (this.currLife > 0)
	{
		this.sprite.draw(context, this.x, this.y, this.width, this.height);
	}
};

DashParticle.prototype.update = function(deltaTime)
{
	if (this.currLife > 0)
	{
		this.currLife -= deltaTime;
		
		this.x += this.velocityX * deltaTime;
		this.y += this.velocityY * deltaTime;
	}
};

DashParticle.prototype.spawn = function(x, y)
{
	this.x = x;// - this.width / 2;
	this.y = y;// - this.height / 2;
	this.x -= this.width / 2;// + (Math.random() * 30 - 15);
	this.y -= this.height / 2;// + (Math.random() * 30 - 15);
	
	this.velocityX = (Math.random() * this.velocityFactor) - (this.velocityFactor / 2);
	this.velocityY = (Math.random() * this.velocityFactor) - (this.velocityFactor / 2);
	
	this.currLife = this.lifeTime;
};
